# Change the device names so that they match the ones in your setup
relay = indigo.devices["008 - Relay Output"]
analog = indigo.devices["008 - Analog Input"]

# Change this array to use your thresholds.  They are assumed
# to go from 0% to 100% in even increments
thresholds=[0,0,0,1240,1395,1550,1880,2090,2200,
    2390,2560,2628,2659,2689,2719,2790,
    9999,9999,9999,9999]

increments = len(thresholds)

def set_relay():
    indigo.device.turnOn(relay, duration=100)

def retrieve_value():
    thread.start_new_thread(set_relay,())
    indigo.activePlugin.sleep(1)
    indigo.device.statusRequest(analog)
    indigo.server.log("sensor value is: " + str(analog.sensorValue))


    sensor = analog.sensorValue

    # Uncomment this line while testing
    # indigo.server.log("HE analog pulse count is: " \
    #    + str(analog.sensorValue))

    for t, threshold in enumerate(thresholds):
        if thresholds[t] <= sensor \
           and sensor <= thresholds[t + 1]:
            rangeBottom = thresholds[t]
        rangeTop = thresholds[t + 1]


    range = (rangeTop - rangeBottom)
    increment = range / increments
    pct = (t * increments) + ((sensor - rangeBottom) / increment)
    return pct


prevPctVar = indigo.variables["PropaneLevel"]
prevPct = prevPctVar.getValue(int, default=0)

pct = 0
retry = 0

while retry < 3:
    pct = retrieve_value()
    delta = prevPct - pct

    if delta <= 10:
        break

    # Might have been a bad reading; retry
    time.sleep(2)
    retry += 1

indigo.server.log("possible bad value, retrying: " + str(pct))
indigo.server.log("Propane reading is: " + str(pct))

level = "%d%%" % (pct)
propaneVar = indigo.variables["PropaneLevel"]
indigo.variable.updateValue(propaneVar, str(pct))
propaneStrVar = indigo.variables["PropaneLevelStr"]
indigo.variable.updateValue(propaneStrVar, level)

